#pragma once

#ifndef __WMAIN__
#define __WMAIN__

#include <Windows.h>

#include <iostream>

struct WMainClass {
	short Width{};
	short Height{};
	bool Windowed{ true };
};

class WMainProg {
protected:
	HWND MainWnd{};
private:
	MSG uMsg{ 0 };
	std::wstring windowstitle{};
	HINSTANCE hInst{};

public:
	int MainLoop();

	long long duration{};

public:
	WMainProg();
	~WMainProg();

	bool Create(WMainClass);
	virtual void wndproc(MSG uMsg) {}

	virtual void Loop() {}
	virtual void Start() {}

	HWND GetMainWnd() { return MainWnd; }
	MSG GetMsg() { return uMsg; }
	void SetWindowName(std::wstring);
};

#endif __WMAIN__